Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/leapfrog_loc.F	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/leapfrog_loc.F	(revision 4446)
@@ -42,4 +42,7 @@
        USE temps_mod, ONLY: itaufin,jD_ref,jH_ref,day_ini,
      &                        day_ref,start_time,dt
+#ifdef CPP_XIOS
+       USE xios, ONLY: xios_update_calendar 
+#endif
        
       IMPLICIT NONE
@@ -204,7 +207,5 @@
       TYPE(distrib),SAVE :: new_dist
 
-      if (ok_iso_verif) then
-         call check_isotopes(q0,ijb_u,ije_u,'leapfrog204: debut')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(q0,ijb_u,ije_u,'leapfrog204: debut')
       
 c$OMP MASTER
@@ -226,7 +227,5 @@
       itaufinp1 = itaufin +1
 
-      if (ok_iso_verif) then
-        call check_isotopes(q0,ijb_u,ije_u,'leapfrog 226')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(q0,ijb_u,ije_u,'leapfrog 226')
 
       itau = 0
@@ -243,7 +242,5 @@
       q=q0
 
-      if (ok_iso_verif) then
-        call check_isotopes(q,ijb_u,ije_u,'leapfrog 239')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 239')
       
 !      iday = day_ini+itau/day_step
@@ -324,7 +321,5 @@
       endif
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 321')
-        endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 321')
 
 #ifdef CPP_IOIPSL
@@ -406,14 +401,10 @@
 
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 400')
-        endif !if (ok_iso_verif) then
+         call check_isotopes(q,ijb_u,ije_u,'leapfrog 400')
 
    2  CONTINUE ! Matsuno backward or leapfrog step begins here
 
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 402')
-        endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 402')
 
 c$OMP MASTER
@@ -497,7 +488,5 @@
 
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 471')
-        endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 471')
 
 !ym  PAS D'AJUSTEMENT POUR LE MOMENT     
@@ -619,7 +608,5 @@
      
       
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 589')
-        endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 589')
       
 c-----------------------------------------------------------------------
@@ -684,7 +671,5 @@
       CALL geopot_loc  ( ip1jmp1, teta  , pk , pks,  phis  , phi   )
         
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 651')
-        endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 651')
       
       call VTb(VTcaldyn)
@@ -725,8 +710,6 @@
 c   -------------------------------------------------------------
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,
+      call check_isotopes(q,ijb_u,ije_u,
      &           'leapfrog 686: avant caladvtrac')
-        endif !if (ok_iso_verif) then
       
       IF( forward. OR . leapf )  THEN
@@ -737,9 +720,12 @@
      .        flxw,pk, iapptrac)
 
+! call creation of mass flux 
+         IF (offline .AND. .NOT. adjust) THEN
+            CALL fluxstokenc_p(pbaru,pbarv,masse,teta,phi)
+         ENDIF
+
          !write(*,*) 'leapfrog 719'
-         if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,
+         call check_isotopes(q,ijb_u,ije_u,
      &           'leapfrog 698: apres caladvtrac')
-         endif !if (ok_iso_verif) then
 
 !      do j=1,nqtot
@@ -775,7 +761,5 @@
 
        !write(*,*) 'leapfrog 720' 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 756')
-        endif !if (ok_iso_verif) then
+       call check_isotopes(q,ijb_u,ije_u,'leapfrog 756')
 
        ! CRisi: pourquoi aller jusqu'à 2 et non pas jusqu'à nqtot?? 
@@ -785,7 +769,5 @@
 
        !write(*,*) 'leapfrog 724'       
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 762')
-        endif !if (ok_iso_verif) then 
+       call check_isotopes(q,ijb_u,ije_u,'leapfrog 762')
  
 !       CALL FTRACE_REGION_END("integrd")
@@ -802,7 +784,5 @@
 #endif    
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 775')
-        endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 775')
 
 c      do j=1,nqtot
@@ -1164,7 +1144,5 @@
        ENDIF ! of IF( apphys )
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1132')
-        endif !if (ok_iso_verif) then
+       call check_isotopes(q,ijb_u,ije_u,'leapfrog 1132')
         !write(*,*) 'leapfrog 1134: iflag_phys=',iflag_phys
 
@@ -1233,7 +1211,5 @@
 
 cc$OMP END PARALLEL
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1196')
-        endif !if (ok_iso_verif) then
+        call check_isotopes(q,ijb_u,ije_u,'leapfrog 1196')
 
 c-----------------------------------------------------------------------
@@ -1470,7 +1446,5 @@
 c              ENDIF
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1430')
-        endif !if (ok_iso_verif) then     
+       call check_isotopes(q,ijb_u,ije_u,'leapfrog 1430')
  
 c   ********************************************************************
@@ -1545,12 +1519,8 @@
 
 #ifdef INCA
-         if (type_trac == 'inca' .OR. type_trac == 'inco') then 
-            call finalize_inca
-         endif
+         if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
 #endif
 #ifdef REPROBUS
-         if (type_trac == 'repr') then
-         call finalize_reprobus
-         endif
+         if (type_trac == 'repr') CALL finalize_reprobus
 #endif
 
@@ -1562,7 +1532,5 @@
       ENDIF
       
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1509')
-        endif !if (ok_iso_verif) then
+      call check_isotopes(q,ijb_u,ije_u,'leapfrog 1509')
 
       IF ( .NOT.purmats ) THEN
@@ -1600,12 +1568,8 @@
 
 #ifdef INCA
-              if (type_trac == 'inca' .OR. type_trac == 'inco') then 
-                 call finalize_inca
-              endif
+              if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
 #endif
 #ifdef REPROBUS
-              if (type_trac == 'repr') then
-         call finalize_reprobus
-              endif
+              if (type_trac == 'repr') CALL finalize_reprobus
 #endif
 
@@ -1649,9 +1613,9 @@
               ENDIF
 #endif
+
+
             ENDIF
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1584')
-        endif !if (ok_iso_verif) then
+            call check_isotopes(q,ijb_u,ije_u,'leapfrog 1584')
 
 c-----------------------------------------------------------------------
@@ -1675,5 +1639,19 @@
              endif
 #endif
-            endif ! of if (leapf.or.(.not.leapf.and.(.not.forward)))
+             
+#ifdef CPP_XIOS
+              IF (ok_dyn_xios) THEN
+c$OMP MASTER
+                 CALL xios_update_calendar(itau)
+c$OMP END MASTER
+c$OMP BARRIER
+                 CALL writedyn_xios(vcov,
+     &                 ucov,teta,pk,phi,q,masse,ps,phis)
+              ENDIF
+#endif
+              
+          endif                 ! of if (leapf.or.(.not.leapf.and.(.not.forward)))
+
+
            ENDIF ! of IF(MOD(itau,iecri).EQ.0)
 
@@ -1696,7 +1674,5 @@
             ENDIF ! of IF (itau.EQ.itaufin)
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1624')
-        endif !if (ok_iso_verif) then
+            call check_isotopes(q,ijb_u,ije_u,'leapfrog 1624')
 
 c-----------------------------------------------------------------------
@@ -1736,7 +1712,5 @@
 
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1664')
-        endif !if (ok_iso_verif) then
+        call check_isotopes(q,ijb_u,ije_u,'leapfrog 1664')
 
 c       ........................................................
@@ -1761,12 +1735,8 @@
 
 #ifdef INCA
-                 if (type_trac == 'inca' .OR. type_trac == 'inco') then 
-                    call finalize_inca
-                 endif
+              if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
 #endif
 #ifdef REPROBUS
-                 if (type_trac == 'repr') then
-         call finalize_reprobus
-                 endif
+                 if (type_trac == 'repr') CALL finalize_reprobus
 #endif
 
@@ -1783,7 +1753,5 @@
 
               
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1698')
-        endif !if (ok_iso_verif) then  
+              call check_isotopes(q,ijb_u,ije_u,'leapfrog 1698')
 
               IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
@@ -1812,4 +1780,6 @@
                ENDIF
 #endif
+               
+
               ENDIF ! of IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin)
 
@@ -1830,5 +1800,17 @@
               endif ! of if (ok_dyn_ins)
 #endif
-              ENDIF ! of IF(MOD(itau,iecri).EQ.0)
+
+#ifdef CPP_XIOS
+              IF (ok_dyn_xios) THEN
+c$OMP MASTER
+                 CALL xios_update_calendar(itau)
+c$OMP END MASTER
+c$OMP BARRIER
+                 CALL writedyn_xios(vcov,
+     &                 ucov,teta,pk,phi,q,masse,ps,phis)
+              ENDIF
+#endif
+              
+           ENDIF                ! of IF(MOD(itau,iecri).EQ.0)
               
 
@@ -1852,7 +1834,5 @@
 
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1750')
-        endif !if (ok_iso_verif) then
+            call check_isotopes(q,ijb_u,ije_u,'leapfrog 1750')
 
       END IF ! of IF(.not.purmats)
@@ -1862,12 +1842,8 @@
 
 #ifdef INCA
-      if (type_trac == 'inca' .OR. type_trac == 'inco') then 
-         call finalize_inca
-      endif
+      if (ANY(type_trac == ['inca','inco'])) CALL finalize_inca
 #endif
 #ifdef REPROBUS
-      if (type_trac == 'repr') then
-         call finalize_reprobus
-      endif
+      if (type_trac == 'repr') CALL finalize_reprobus
 #endif
 
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/mod_const_mpi.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/mod_const_mpi.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/mod_const_mpi.F90	(revision 4446)
@@ -88,4 +88,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 #ifdef CPP_XIOS
+      WRITE(*,*)'IN Init_mpi call wxios_init'
       CALL wxios_init("LMDZ", outcom=COMM_LMDZ)
 #endif
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/mod_xios_dyn3dmem.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/mod_xios_dyn3dmem.F90	(revision 4446)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/mod_xios_dyn3dmem.F90	(revision 4446)
@@ -0,0 +1,262 @@
+!
+! $Id$
+!
+! This module contains the interface between the LMDZ dynamics dyn3dmem module and XIOS.
+! 
+! Lists of subroutines
+!      xios_dyn3dmem_init : context / calendar / domain / axis initialisations
+!
+! Initialisation of communicator between LMDZ and XIOS is done elsewhere: wxios_init called by init_const_mpi 
+!                                                                         (one of the first calls in gcm.F90)
+! L. Fairhead 11/2017
+!
+!
+#ifdef CPP_XIOS
+
+MODULE mod_xios_dyn3dmem
+
+     USE xios
+     USE wxios, ONLY : g_comm
+     CHARACTER(len=100), SAVE :: dyn3d_ctx_name = "LMDZDYN"
+     TYPE(xios_context), SAVE :: dyn3d_ctx_handle
+!$OMP THREADPRIVATE(dyn3d_ctx_name, dyn3d_ctx_handle)
+ 
+  INTERFACE writefield_dyn_u
+     MODULE PROCEDURE writefield_dyn1d_u, writefield_dyn2d_u
+  END INTERFACE writefield_dyn_u
+
+  INTERFACE writefield_dyn_v
+     MODULE PROCEDURE writefield_dyn1d_v, writefield_dyn2d_v
+  END INTERFACE writefield_dyn_v
+
+     REAL, ALLOCATABLE, SAVE :: NewField_U(:,:,:), NewField_V(:,:,:)
+  
+
+   CONTAINS
+
+   SUBROUTINE xios_dyn3dmem_init(xios_cal_type, anref, moisref, jourref,heureref, an, mois, jour, heure, zdtvr)
+
+
+     USE comvert_mod, ONLY: presnivs
+     USE parallel_lmdz
+
+     IMPLICIT NONE
+
+     INCLUDE 'dimensions.h'
+     INCLUDE "paramet.h"
+     INCLUDE 'comgeom.h'
+
+     TYPE(xios_duration) :: tstep_xios
+     TYPE(xios_date)                :: start_date
+     TYPE(xios_date)                :: time_origin
+     INTEGER :: an, mois, jour
+     REAL :: heure
+     CHARACTER (len=10) :: xios_cal_type
+     INTEGER :: anref, moisref, jourref
+     REAL :: heureref
+     REAL :: zdtvr
+     TYPE(xios_domain) :: dom_grid_U, dom_grid_V, dom_grid_T
+     REAL :: rlong(iip1), rlat(jjp1)
+     REAL :: pi
+     INTEGER :: ii, jj, jjb, jje, jjn
+
+!      WRITE(*,*)'Entree mod_xios_dyn3dmem'
+
+! 0 Initialisations
+     pi = 4. * ATAN (1.)
+! allocation of fields passed to xios
+!$OMP BARRIER
+!$OMP MASTER
+     allocate(NewField_U(iip1, jj_begin:jj_end, llm))
+     allocate(NewField_V(iip1, jj_begin:jj_end, llm))     
+!$OMP END MASTER
+!$OMP BARRIER
+
+! 1 Context initialisation
+!$OMP MASTER
+     CALL xios_context_initialize(dyn3d_ctx_name, g_comm)
+     CALL xios_get_handle(dyn3d_ctx_name, dyn3d_ctx_handle)
+     CALL xios_set_current_context(dyn3d_ctx_handle)  
+
+!     WRITE(*,*)'apres context initialisation mod_xios_dyn3dmem'
+
+! 2 calendar stuff
+
+     tstep_xios%second=zdtvr
+     CALL xios_define_calendar(type=xios_cal_type, start_date=xios_date(an, mois, jour,INT(heure),0,0), &
+            time_origin=xios_date(anref,moisref,jourref,INT(heureref),0,0), timestep=tstep_xios)
+
+!     WRITE(*,*)'apres  calendrier mod_xios_dyn3dmem'
+
+! 3 domain / grids / axis
+! Domains:
+      rlong(:) = rlonu(:) * 180. / pi
+      rlat(:) = rlatu(:) * 180. / pi
+
+      CALL xios_set_domain_attr("domain_U", ni_glo=iip1, nj_glo=jjp1,          &
+          type="rectilinear",ibegin=0, ni=iip1, jbegin=jj_begin-1, nj=jj_nb,   &
+          data_dim = 2, lonvalue_1d=rlong(1:iip1), latvalue_1d=rlat(jj_begin:jj_end))
+
+      jjb=jj_begin
+      jje=jj_end
+      jjn=jj_nb
+      IF (pole_sud) jjn=jjn-1
+      IF (pole_sud) jje=jje-1
+
+
+      rlong(:) = rlonv(:) * 180. / pi
+      do jj = jjb, jje
+        rlat(jj) = rlatv(jj) * 180. / pi
+      enddo
+      
+      CALL xios_set_domain_attr("domain_V", ni_glo=iip1, nj_glo=jjm,            &
+          type="rectilinear",ibegin=0, ni=iip1, jbegin=jj_begin-1, nj=jjn,   &
+          data_dim = 2, lonvalue_1d=rlong(1:iip1), latvalue_1d=rlat(jjb:jje))
+
+
+      rlong(:) = rlonv(:) * 180. / pi
+      rlat(:) = rlatu(:) * 180. / pi 
+      CALL xios_set_domain_attr("domain_T", ni_glo=iip1, nj_glo=jjp1,          &
+          type="rectilinear",ibegin=0, ni=iip1, jbegin=jj_begin-1, nj=jj_nb,   &
+          data_dim = 2, lonvalue_1d=rlong(1:iip1), latvalue_1d=rlat(jj_begin:jj_end))
+      
+!     WRITE(*,*)'apres  domaine mod_xios_dyn3dmem'
+! Vertical axis
+       CALL xios_set_axis_attr("presnivs",n_glo=llm,value=presnivs)
+!     WRITE(*,*)'apres  vertical axis mod_xios_dyn3dmem'
+! 4 end of context definition
+       CALL xios_close_context_definition()
+!     WRITE(*,*)'apres close context init. axis mod_xios_dyn3dmem'
+!$OMP END MASTER
+   END SUBROUTINE xios_dyn3dmem_init
+
+   SUBROUTINE  writefield_dyn1d_u(name,Field)
+
+     USE parallel_lmdz
+     IMPLICIT NONE
+     include 'dimensions.h'
+     include 'paramet.h'
+     CHARACTER(LEN=*)   :: name
+     REAL, DIMENSION(ij_begin:ij_end) :: Field
+     REAL, DIMENSION(iip1,  jj_begin:jj_end) :: NewField
+      LOGICAL,SAVE :: debuglf=.true.
+!$OMP THREADPRIVATE(debuglf)
+     
+     NewField(:,jj_begin:jj_end)=reshape(Field(ij_begin:ij_end),(/iip1,jj_nb/))
+
+!$OMP BARRIER       
+!$OMP MASTER
+     CALL xios_send_field(name, NewField)
+!$OMP END MASTER   
+  
+   END SUBROUTINE  writefield_dyn1d_u
+
+   SUBROUTINE  writefield_dyn2d_u(name,Field)
+
+     USE parallel_lmdz
+     IMPLICIT NONE
+     include 'dimensions.h'
+     include 'paramet.h'
+     CHARACTER(LEN=*)   :: name
+     REAL, DIMENSION(ij_begin:ij_end,llm) :: Field
+!     REAL, ALLOCATABLE, SAVE :: NewField(:,:,:)
+     INTEGER :: i,j,l, count
+
+!!!!!$OMP BARRIER
+!!!!!$OMP MASTER
+!!!!     allocate(NewField(iip1, jj_begin:jj_end, llm))
+!!!!!$OMP END MASTER
+!!!!!$OMP BARRIER
+
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
+     DO l = 1, llm
+       NewField_U(:,jj_begin:jj_end,l)=reshape(Field(ij_begin:ij_end,l),(/iip1,jj_nb/))
+     ENDDO
+!$OMP ENDDO
+!$OMP BARRIER 
+
+!$OMP MASTER
+     CALL xios_send_field(name, NewField_U)
+!!!!     DEALLOCATE(NewField)
+!$OMP END MASTER   
+!$OMP BARRIER
+  
+   END SUBROUTINE  writefield_dyn2d_u
+
+   SUBROUTINE  writefield_dyn1d_v(name,Field)
+
+     USE parallel_lmdz
+     IMPLICIT NONE
+     include 'dimensions.h'
+     include 'paramet.h'
+     CHARACTER(LEN=*)   :: name
+     REAL, DIMENSION(ij_begin:ij_end) :: Field
+     REAL, DIMENSION(iip1,  jj_begin:jj_end) :: NewField
+     INTEGER ::  jje, ije, jjn
+
+     IF (pole_sud) THEN
+       jje=jj_end-1
+       ije=ij_end-iip1
+       jjn=jj_nb-1
+     ELSE
+       jje=jj_end
+       ije=ij_end
+       jjn=jj_nb
+     ENDIF
+
+     NewField(:,jj_begin:jje)=reshape(Field(ij_begin:ije),(/iip1,jjn/))
+
+!$OMP BARRIER       
+!$OMP MASTER
+     CALL xios_send_field(name, NewField(:,jj_begin:jje))
+!$OMP END MASTER   
+  
+   END SUBROUTINE  writefield_dyn1d_v
+
+   SUBROUTINE  writefield_dyn2d_v(name,Field)
+
+     USE parallel_lmdz
+     IMPLICIT NONE
+     include 'dimensions.h'
+     include 'paramet.h'
+     CHARACTER(LEN=*)   :: name
+     REAL, DIMENSION(ij_begin:ij_end,llm) :: Field
+!!!!     REAL, ALLOCATABLE, SAVE :: NewField(:,:,:)
+     INTEGER :: l, jje, ije, jjn
+
+!!!!!$OMP BARRIER
+!!!!!$OMP MASTER
+!!!!     allocate(NewField(iip1,  jj_begin:jj_end,llm))
+!!!!!$OMP END MASTER
+!!!!!$OMP BARRIER
+
+     IF (pole_sud) THEN
+       jje=jj_end-1
+       ije=ij_end-iip1
+       jjn=jj_nb-1
+     ELSE
+       jje=jj_end
+       ije=ij_end
+       jjn=jj_nb
+     ENDIF
+
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+     DO l = 1, llm
+        NewField_V(:,jj_begin:jje,l)=reshape(Field(ij_begin:ije,l),(/iip1,jjn/))
+     ENDDO
+!$OMP ENDDO
+!$OMP BARRIER       
+
+!$OMP MASTER
+     CALL xios_send_field(name, NewField_V(:,jj_begin:jje,:))
+!!!!     DEALLOCATE(NewField)
+!$OMP END MASTER   
+!$OMP BARRIER 
+  
+   END SUBROUTINE  writefield_dyn2d_v
+   
+END MODULE mod_xios_dyn3dmem 
+#endif
+
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/qminimum_loc.F
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/qminimum_loc.F	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/qminimum_loc.F	(revision 4446)
@@ -4,6 +4,8 @@
       SUBROUTINE qminimum_loc( q,nqtot,deltap )
       USE parallel_lmdz
-      USE infotrac, ONLY: niso,ntraciso,iqiso,ok_iso_verif,             &
-     &   ratiomin,qperemin ! CRisi 23nov2020
+      USE infotrac, ONLY: niso, ntiso, iqIsoPha, tracers, 
+     &                    isoCheck, min_qParent
+      USE strings_mod, ONLY: strIdx
+      USE readTracFiles_mod, ONLY: addPhase
       IMPLICIT none
 c
@@ -18,10 +20,9 @@
       REAL q(ijb_u:ije_u,llm,nqtot), deltap(ijb_u:ije_u,llm)
 c
-      INTEGER iq_vap, iq_liq
-      PARAMETER ( iq_vap = 1 ) ! indice pour l'eau vapeur
-      PARAMETER ( iq_liq = 2 ) ! indice pour l'eau liquide
-      REAL seuil_vap, seuil_liq
-      PARAMETER ( seuil_vap = 1.0e-10 ) ! seuil pour l'eau vapeur
-      PARAMETER ( seuil_liq = 1.0e-11 ) ! seuil pour l'eau liquide
+      LOGICAL, SAVE :: first=.TRUE.
+      INTEGER, SAVE :: iq_vap, iq_liq        ! indices pour l'eau vapeur/liquide
+c$OMP THREADPRIVATE(iq_vap, iq_liq, first)
+      REAL, PARAMETER :: seuil_vap = 1.0e-10 ! seuil pour l'eau vapeur
+      REAL, PARAMETER :: seuil_liq = 1.0e-11 ! seuil pour l'eau liquide
 c
 c  NB. ....( Il est souhaitable mais non obligatoire que les valeurs des
@@ -54,18 +55,31 @@
 c
 
-        !write(lunout,*) 'qminimum 52: entree'
-        if (ok_iso_verif) then
-           call check_isotopes(q,ij_begin,ij_end,'qminimum 52')   
-        endif !if (ok_iso_verif) then     
+c$OMP BARRIER
+
+      !write(lunout,*) 'qminimum 52: entree'
+      IF(first) THEN
+         iq_vap = strIdx(tracers(:)%name, addPhase('H2O', 'g'))
+         iq_liq = strIdx(tracers(:)%name, addPhase('H2O', 'l'))
+         first = .FALSE.
+      END IF
+      call check_isotopes(q,ij_begin,ij_end,'qminimum 52')   
 
       ijb=ij_begin
       ije=ij_end
 
-      zx_defau_diag(ijb:ije,:,:)=0.0
-      q_follow(ijb:ije,:,1:2)=q(ijb:ije,:,1:2)  
+      DO k = 1, llm
+c$OMP DO SCHEDULE(STATIC)
+        DO i = ijb, ije
+          zx_defau_diag(i,k,1)=0.0
+          zx_defau_diag(i,k,2)=0.0
+          q_follow(i,k,1)=q(i,k,1)
+          q_follow(i,k,2)=q(i,k,2)
+        ENDDO
+c$OMP END DO NOWAIT
+      ENDDO
 
       !write(lunout,*) 'qminimum 57'
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO 1000 k = 1, llm
+c$OMP DO SCHEDULE(STATIC)       
       DO 1040 i = ijb, ije
             if (seuil_liq - q(i,k,iq_liq) .gt. 0.d0 ) then
@@ -78,9 +92,6 @@
             endif
  1040 CONTINUE
+c$OMP END DO NOWAIT
  1000 CONTINUE
-c$OMP END DO NOWAIT
-c$OMP BARRIER
-c --->  SYNCHRO OPENMP ICI
-
 
 c
@@ -109,5 +120,4 @@
 c$OMP END DO NOWAIT
       ENDDO
-c$OMP BARRIER
 
 c
@@ -126,5 +136,5 @@
          ENDIF
       ENDDO
-c$OMP END DO  
+c$OMP END DO NOWAIT 
 !      pompe = SSUM(ije-ijb+1,zx_pump(ijb),1)
 
@@ -158,5 +168,5 @@
         endif !if (zx_pump(i).gt.0.0) then
       enddo !DO i = ijb, ije  
-c$OMP END DO
+c$OMP END DO NOWAIT
 
       ! 2) transfert de vap vers les couches plus hautes
@@ -169,5 +179,5 @@
 !              write(lunout,*) 'i,k,q_follow(i,k-1,iq_vap)=',
 !     :                 i,k,q_follow(i,k-1,iq_vap)          
-              if (q_follow(i,k-1,iq_vap).lt.qperemin) then
+              if (q_follow(i,k-1,iq_vap).lt.min_qParent) then
                 write(lunout,*) 'tmp qmin: on stoppe'
                 write(lunout,*) 'zx_pump(i)=',zx_pump(i)
@@ -177,29 +187,29 @@
                 call abort_gcm("qminimum","not enough vapor",1)
               endif  
-            do ixt=1,ntraciso
+            do ixt=1,ntiso
 !                write(lunout,*) 'qmin 168: ixt=',ixt
-!                write(lunout,*) 'q(i,k,iqiso(ixt,iq_vap)=',
-!     :             q(i,k,iqiso(ixt,iq_vap))
+!                write(lunout,*) 'q(i,k,iqIsoPha(ixt,iq_vap)=',
+!     :             q(i,k,iqIsoPha(ixt,iq_vap))
 !                write(lunout,*) 'zx_defau_diag(i,k,iq_vap)=',
 !     :                  zx_defau_diag(i,k,iq_vap)
-!                write(lunout,*) 'q(i,k-1,iqiso(ixt,iq_vap)=',
-!     :                   q(i,k-1,iqiso(ixt,iq_vap))     
-
-               q(i,k,iqiso(ixt,iq_vap))=q(i,k,iqiso(ixt,iq_vap))
-     :              +zx_defau_diag(i,k,iq_vap)
-     :              *q(i,k-1,iqiso(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
+!                write(lunout,*) 'q(i,k-1,iqIsoPha(ixt,iq_vap)=',
+!     :                   q(i,k-1,iqIsoPha(ixt,iq_vap))     
+
+               q(i,k,iqIsoPha(ixt,iq_vap))=q(i,k,iqIsoPha(ixt,iq_vap))
+     :           +zx_defau_diag(i,k,iq_vap)
+     :           *q(i,k-1,iqIsoPha(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
                 
-              if (ok_iso_verif) then
-                if (iso_verif_noNaN_nostop(q(i,k,iqiso(ixt,iq_vap)),
+              if (isoCheck) then
+                if(iso_verif_noNaN_nostop(q(i,k,iqIsoPha(ixt,iq_vap)),
      :                   'qminimum 155').eq.1) then
                    write(*,*) 'i,k,ixt=',i,k,ixt
                    write(*,*) 'q_follow(i,k-1,iq_vap)=',
      :                   q_follow(i,k-1,iq_vap)
-                   write(*,*) 'q(i,k,iqiso(ixt,iq_vap))=',
-     :                   q(i,k,iqiso(ixt,iq_vap))
+                   write(*,*) 'q(i,k,iqIsoPha(ixt,iq_vap))=',
+     :                   q(i,k,iqIsoPha(ixt,iq_vap))
                    write(*,*) 'zx_defau_diag(i,k,iq_vap)=',
      :                   zx_defau_diag(i,k,iq_vap)
-                   write(*,*) 'q(i,k-1,iqiso(ixt,iq_vap))=',
-     :                   q(i,k-1,iqiso(ixt,iq_vap))
+                   write(*,*) 'q(i,k-1,iqIsoPha(ixt,iq_vap))=',
+     :                   q(i,k-1,iqIsoPha(ixt,iq_vap))
                    stop
                 endif
@@ -207,21 +217,24 @@
 
               ! et on la retranche en k-1
-               q(i,k-1,iqiso(ixt,iq_vap))=q(i,k-1,iqiso(ixt,iq_vap))
+               q(i,k-1,iqIsoPha(ixt,iq_vap)) =
+     :            q(i,k-1,iqIsoPha(ixt,iq_vap))
      :              -zx_defau_diag(i,k,iq_vap)
      :              *deltap(i,k)/deltap(i,k-1)
-     :              *q(i,k-1,iqiso(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
-
-               if (ok_iso_verif) then
-                if (iso_verif_noNaN_nostop(q(i,k-1,iqiso(ixt,iq_vap)),
+     :              *q(i,k-1,iqIsoPha(ixt,iq_vap))
+     :              /q_follow(i,k-1,iq_vap)
+
+               if (isoCheck) then
+                if (iso_verif_noNaN_nostop(
+     :              q(i,k-1,iqIsoPha(ixt,iq_vap)),
      :                   'qminimum 175').eq.1) then
                    write(*,*) 'k,i,ixt=',k,i,ixt
                    write(*,*) 'q_follow(i,k-1,iq_vap)=',
      :                   q_follow(i,k-1,iq_vap)
-                   write(*,*) 'q(i,k,iqiso(ixt,iq_vap))=',
-     :                   q(i,k,iqiso(ixt,iq_vap))
+                   write(*,*) 'q(i,k,iqIsoPha(ixt,iq_vap))=',
+     :                   q(i,k,iqIsoPha(ixt,iq_vap))
                    write(*,*) 'zx_defau_diag(i,k,iq_vap)=',
      :                   zx_defau_diag(i,k,iq_vap)
-                   write(*,*) 'q(i,k-1,iqiso(ixt,iq_vap))=',
-     :                   q(i,k-1,iqiso(ixt,iq_vap))
+                   write(*,*) 'q(i,k-1,iqIsoPha(ixt,iq_vap))=',
+     :                   q(i,k-1,iqIsoPha(ixt,iq_vap))
                    stop
                 endif
@@ -236,10 +249,8 @@
           endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
         enddo !DO i = 1, ip1jmp1        
-c$OMP END DO
+c$OMP END DO NOWAIT
         enddo !do k=2,llm
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb,ije,'qminimum 168')
-        endif !if (ok_iso_verif) then
+        call check_isotopes(q,ijb,ije,'qminimum 168')
         
       
@@ -252,12 +263,12 @@
 
               ! on ajoute eau liquide en k en k              
-              do ixt=1,ntraciso
-               q(i,k,iqiso(ixt,iq_liq))=q(i,k,iqiso(ixt,iq_liq))
+              do ixt=1,ntiso
+               q(i,k,iqIsoPha(ixt,iq_liq))=q(i,k,iqIsoPha(ixt,iq_liq))
      :              +zx_defau_diag(i,k,iq_liq)
-     :              *q(i,k,iqiso(ixt,iq_vap))/q_follow(i,k,iq_vap)
+     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,iq_vap)
               ! et on la retranche à la vapeur en k
-               q(i,k,iqiso(ixt,iq_vap))=q(i,k,iqiso(ixt,iq_vap))
+               q(i,k,iqIsoPha(ixt,iq_vap))=q(i,k,iqIsoPha(ixt,iq_vap))
      :              -zx_defau_diag(i,k,iq_liq)
-     :              *q(i,k,iqiso(ixt,iq_vap))/q_follow(i,k,iq_vap)   
+     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,iq_vap)   
               enddo !do ixt=1,niso
               q_follow(i,k,iq_liq)=   q_follow(i,k,iq_liq)
@@ -267,13 +278,13 @@
           endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
         enddo !DO i = ijb, ije
-c$OMP END DO        
+c$OMP END DO NOWAIT       
        enddo !do k=2,llm  
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb,ije,'qminimum 197')
-        endif !if (ok_iso_verif) then
+       call check_isotopes(q,ijb,ije,'qminimum 197')
 
       endif !if (niso > 0) then
       !write(*,*) 'qminimum 188'
+c$OMP BARRIER
+
 c
       RETURN
